/*###########################################################################
#                                                                           #
#   		 		         ^C}[vO							#
#                                                                           #
###########################################################################*/
#define __MENU003_C__
#include "project.h"

/* [J֐vg^Cv錾	*/
static void screenInit( void );
static void drawTitle( uint8_t type );
static void selectItem( uint8_t itemIndex );
static void PG_drawWeekCheck( uint8_t wday ,uint8_t sw );
static void PG_dispInfo( uint8_t pgIndex ,PG *pg );
static void PG_drawActive( PG *pg );
static void PG_drawIR( PG *pg );
static void PG_drawDate( PG *pg );
static void PG_drawTime( PG *pg );
static void PG_drawType( PG *pg );
static void PG_drawWeek( PG *pg );

/* O[oϐ錾			*/
extern uint8_t pgFlag[];

/* J[\We[u			*/
static const prog_uint8_t tbl_x1[] = {  0,  0, 25, 46,  95, 87, 107, 85, 107,  1, 13, 25, 37, 49, 61, 73 };
static const prog_uint8_t tbl_y1[] = {  0,  9, 10,  9,  12, 22,  22, 33,  33, 21, 21, 21, 21, 21, 21, 21 };
static const prog_uint8_t tbl_x2[] = { 24, 20, 42, 86, 119, 98, 119, 97, 119, 11, 23, 35, 47, 59, 71, 83 };
static const prog_uint8_t tbl_y2[] = {  8, 19, 18, 19,  20, 30,  30, 41,  41, 31, 31, 31, 31, 31, 31, 31 };

/*****************************************************************************
*								^C}[vO
* Fvoid
* ߒlFuint8_t ̉ʔԍ
*****************************************************************************/
uint8_t menu003( void )
{
	static uint8_t pgIndex = 0;				/* vOԍ				*/

	uint8_t ky;
	uint8_t itemIndex = 0;					/* ACeԍ					*/
	PG pg;

	/* L[s[gݒ		*/
	keysRepetEnable( KEY_UP     ,ON );
	keysRepetEnable( KEY_DOWN   ,ON );
	keysRepetEnable( KEY_LEFT   ,ON );
	keysRepetEnable( KEY_RIGHT  ,ON );
	keysRepetEnable( KEY_ENTER  ,OFF );
	keysRepetEnable( KEY_CANCEL ,OFF );

	/* vOǂݍ			*/
	eep_pgRead( pgIndex ,&pg );

	/* ʏ					*/
	screenInit();
	PG_dispInfo( pgIndex ,&pg );			/* l\					*/
	selectItem( itemIndex );				/* J[\\					*/
	keysClear();

	/* C[v			*/
	while ( 1 ) {

		/* 10msec̃L[|[O		*/
		wdt_reset();
		while ( !RTC_TICK_MS10 );			/* 10msecoߑ҂				*/
		RTC_TICK_MS10 = 0;
		keysWatchKey();						/* L[|[O				*/
		ky = keysInkey();					/* L[obt@o			*/
		progTimerPoll();					/* vO|[O			*/

		/* G^[L[̏		*/
		if ( ky == KEY_ENTER ) {
			if ( itemIndex == 0 ) {			/* I[hH					*/
				selectItem( itemIndex );
				itemIndex = 1;
				selectItem( itemIndex );
				drawTitle( 1 );

			} else {						/* ҏW[hH					*/
				selectItem( itemIndex );
				itemIndex = 0;
				eep_pgWrite( pgIndex ,&pg );
				progInitExecFlag();			/* vOsσtOZbg	*/
				drawMessageImage( img031 ,57 ,9 ,10 );	/* "ݒ肵܂"	*/
				screenInit();
				PG_dispInfo( pgIndex ,&pg );
				selectItem( itemIndex );
				keysClear();
			}

		/* LZL[̏	*/
		} else if ( ky == KEY_CANCEL ) {
			if ( itemIndex == 0 ) {			/* I[hH					*/
				return( 0 );

			} else {						/* ҏW[hH					*/
				selectItem( itemIndex );
				itemIndex = 0;
				eep_pgRead( pgIndex ,&pg );
				drawMessageImage( img027 ,85 ,9 ,10 );	/* "LZ܂"	*/
				screenInit();
				PG_dispInfo( pgIndex ,&pg );
				selectItem( itemIndex );
				keysClear();
			}

		/* ㉺L[̏			*/
		} else if ( ( ky == KEY_UP ) || ( ky == KEY_DOWN ) ) {
			selectItem( itemIndex );
			if ( itemIndex == 0 ) {			/* I[hH	*/
				if ( ky == KEY_UP ) {
					if ( ++pgIndex >= PG_COUNT ) {
						pgIndex = 0;
					}
				} else {
					if ( --pgIndex == 0xff ) {
						pgIndex = PG_COUNT - 1;
					}
				}
				eep_pgRead( pgIndex ,&pg );
				PG_dispInfo( pgIndex ,&pg );

			} else {						/* ҏW[hH	*/
				if ( itemIndex == 1 ) {										/* L^			*/
					pg.active ^= 1;
					PG_drawActive( &pg );

				} else if ( itemIndex == 2 ) {								/* IRԍ				*/
					if ( ky == KEY_UP ) {
						if ( ++pg.irIndex == IR_COUNT ) {
							pg.irIndex = 0;
						}
					} else {
						if ( --pg.irIndex == 0x1f ) {	/* 5bit̃tB[hȂ̂-10x1fƂȂ		*/
							pg.irIndex = IR_COUNT - 1;
						}
					}
					PG_drawIR( &pg );

				} else if ( itemIndex == 3 ) {								/* w^TԎw	*/
					pg.type ^= 1;
					PG_drawType( &pg );
					PG_drawWeek( &pg );

				} else if ( ( itemIndex >= 4 ) && ( itemIndex <= 6 ) ) {	/* N^^			*/
					TIME tm;
					memset( &tm ,0x00 ,sizeof(TIME) );
					tm.year = pg.year; tm.month = pg.month; tm.day = pg.day;
					date_stepValue( &tm ,itemIndex - 4 ,( ky == KEY_UP )?0:1 );
					pg.year = tm.year; pg.month = tm.month; pg.day = tm.day;
					PG_drawWeek( &pg );

				} else if ( ( itemIndex >= 7 ) && ( itemIndex <= 8 ) ) {	/* ^				*/
					TIME tm;
					memset( &tm ,0x00 ,sizeof(TIME) );
					tm.hour = pg.hour; tm.minute = pg.minute;
					date_stepValue( &tm ,itemIndex - 4 ,( ky == KEY_UP )?0:1 );
					pg.hour = tm.hour; pg.minute = tm.minute;
					PG_drawTime( &pg );

				} else {													/* j`yj		*/
					uint8_t wday = itemIndex - 9;
					uint8_t bit = _BV( wday );
					pg.week ^= bit;
					PG_drawWeekCheck( wday ,pg.week & bit );
				}
			}
			selectItem( itemIndex );

		/* EL[̏			*/
		} else if ( ( itemIndex != 0 ) && ( ( ky == KEY_RIGHT ) || ( ky == KEY_LEFT ) ) ) {
			selectItem( itemIndex );
			if ( ky == KEY_RIGHT ) {
				if ( ++itemIndex == 16 ) {
					itemIndex = 1;
				}
				if ( ( pg.type == 0 ) && ( itemIndex == 4 ) ) {			/* TԎw̏ꍇ͔NXLbv	*/
					itemIndex = 7;
				} else if ( ( pg.type != 0 ) && ( itemIndex == 9 ) ) {	/* w̏ꍇ͗jXLbv	*/
					itemIndex = 1;
				}
			} else {
				if ( --itemIndex == 0 ) {
					itemIndex = 15;
				}
				if ( ( pg.type == 0 ) && ( itemIndex == 6 ) ) {			/* TԎw̏ꍇ͔NXLbv	*/
					itemIndex = 3;
				} else if ( ( pg.type != 0 ) && ( itemIndex == 15 ) ) {	/* w̏ꍇ͗jXLbv	*/
					itemIndex = 8;
				}
			}
			selectItem( itemIndex );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*							ʘg`
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void screenInit( void )
{
	uint8_t i;

	/* ^Cg\			*/
	LCD_clr();
	drawTitle( 0 );

	/* "PG"\				*/
	LCD_Gputs_P( 1 ,1 ,PSTR("PG") );

	/* "IR"\				*/
	LCD_Gputs_P( 25 ,11 ,PSTR("IR") );

	/* TԃvOg\	*/
	LCD_drawRect( 0 ,20 ,84 ,43 );
	LCD_drawLine( 1 ,32 ,83 ,32 );

	for ( i = 10 ;i <= 15 ;i++ ) {
		uint8_t x = pgm_read_byte( &tbl_x1[i] ) - 1;
		LCD_drawLine( x ,21 ,x ,42 );
	}

	for ( i = 0 ;i < 7 ;i++ ) {
		LCD_drawBMP( img010[i] ,pgm_read_byte( &tbl_x1[ i + 9 ] ) + 1 ,pgm_read_byte( &tbl_y1[ i + 9 ] ) + 1 ,9 ,9 );
	}

	/* E\			*/
	LCD_drawBMP( img007 , 98 ,33 ,9 ,9 );	/*  */
	LCD_drawBMP( img008 ,120 ,33 ,9 ,9 );	/*  */
}

/*****************************************************************************
*								^Cg^tb^[`
* Fuint8_t type 0 : Iʗp
*					 1 : ҏWʗp
* ߒlFvoid
*****************************************************************************/
static void drawTitle( uint8_t type )
{
	LCD_clearRect( 0 ,45 ,127 ,63 );
	if ( type == 0 ) {
		drawTitleImage( img040 ,59 ,9 ,45 );		/* "<<vOI>>"			*/
		LCD_drawBMP( img032 ,7 ,45 ,113 ,19 );		/* "EnterFҏW FPGI"	*/
													/* "Cancel:I				"	*/
	} else {
		drawTitleImage( img041 ,59 ,9 ,45 );		/* "<<vOҏW>>"			*/
		LCD_drawBMP( img037 ,9 ,45 ,110 ,19 );		/* "EnterFm FI"		*/
													/* "Cancel:@FύX"	*/
	}
}

/*****************************************************************************
*							ACeZNg
* Fuint8_t itemIndex ACeԍ  0 : PG
*                                       1 : L^
*                                       2 : IR
*                                       3 : w^TԎw
*                                       4 : N
*                                       5 : 
*                                       6 : 
*                                       7 : 
*                                       8 : 
*                                       9 : j
*                                      10 : j
*                                      11 : Ηj
*                                      12 : j
*                                      13 : ؗj
*                                      14 : j
*                                      15 : yj
* ߒlFvoid
*****************************************************************************/
static void selectItem( uint8_t itemIndex )
{
	uint8_t x1 = pgm_read_byte( &tbl_x1[ itemIndex ] );
	uint8_t y1 = pgm_read_byte( &tbl_y1[ itemIndex ] );
	uint8_t x2 = pgm_read_byte( &tbl_x2[ itemIndex ] );
	uint8_t y2 = pgm_read_byte( &tbl_y2[ itemIndex ] );
	LCD_invertRect( x1 ,y1 ,x2 ,y2 );
}

/*****************************************************************************
*						TԃvO`FbN\
* Fuint8_t wday 0: 1: 2: 3: 4: 5: 6:y
*		uint8_t sw   0:`FbN  !0:`FbN`
* ߒlFvoid
*****************************************************************************/
static void PG_drawWeekCheck( uint8_t wday ,uint8_t sw )
{
	uint8_t x = 1 + ( wday * 12 );
	if ( sw ) {
		LCD_drawBMP( img034 ,x ,34 ,10 ,8 );
	} else {
		LCD_clearRect( x ,34 ,x + 9 ,42 );
	}
}

/*****************************************************************************
*							vO\
* Fuint8_t pgIndex vOԍ(0`98)
*		PG      *pg		vO\
* ߒlFvoid
*****************************************************************************/
static void PG_dispInfo( uint8_t pgIndex ,PG *pg )
{
	char buf[4];

	/* PGԍ\				*/
	Uint16ToString( buf ,pgIndex + 1 ,2 ,'0' );
	LCD_Gputs( 13 ,1 ,buf );

	/* LE\			*/
	PG_drawActive( pg );

	/* IRԍ\				*/
	PG_drawIR( pg );

	/* \					*/
	PG_drawTime( pg );

	/* uTԐݒvuݒv	*/
	PG_drawType( pg );

	/* Tԕ\\				*/
	PG_drawWeek( pg );
}

/*****************************************************************************
*								L^\
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawActive( PG *pg )
{
	LCD_drawBMP( ( pg->active == 0 ) ? img036 : img035 ,1 ,10 ,19 ,9 );
}

/*****************************************************************************
*								IRl\
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawIR( PG *pg )
{
	char buf[4];
	Uint16ToString( buf ,pg->irIndex + 1 ,1 ,' ' );
	LCD_Gputs( 37 ,11 ,buf );
}

/*****************************************************************************
*						tl\
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawDate( PG *pg )
{
	char buf[6];

	Uint16ToString( buf ,pg->year ,4 ,'0' );			/* N\	*/
	LCD_Gputs( 96 ,13 ,buf );

	Uint16ToString( buf ,pg->month ,2 ,' ' );			/* \	*/
	LCD_Gputs( 87 ,23 ,buf );

	Uint16ToString( buf ,pg->day ,2 ,' ' );				/* \	*/
	LCD_Gputs( 108 ,23 ,buf );
}

/*****************************************************************************
*						l\
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawTime( PG *pg )
{
	char buf[4];

	Uint16ToString( buf ,pg->hour ,2 ,'0' );			/* \	*/
	LCD_Gputs( 86 ,34 ,buf );

	Uint16ToString( buf ,pg->minute ,2 ,'0' );			/* \	*/
	LCD_Gputs( 108 ,34 ,buf );
}

/*****************************************************************************
*						TԐݒ@^@ݒ@`
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawType( PG *pg )
{
	LCD_drawBMP( ( pg->type == 0 ) ? img038 : img039 ,47 ,10 ,39 ,9 );
}

/*****************************************************************************
*								Tԕ\`
* FPG *pg
* ߒlFvoid
*****************************************************************************/
static void PG_drawWeek( PG *pg )
{
	/* TԃvO\		*/
	if ( pg->type == 0 ) {
		for ( uint8_t i = 0 ;i < 7 ;i++ ) {
			PG_drawWeekCheck( i ,pg->week & _BV(i) );
		}
		LCD_clearRect( 86 ,12 ,127 ,31 );			/* tNA	*/

	/* vO\		*/
	} else {
		TIME tim;
		memset( &tim ,0 ,sizeof(TIME) );
		tim.year = pg->year;
		tim.month = pg->month;
		tim.day = pg->day;
		tim.wday = (uint8_t)( ( date_greg2mjd( tim.year ,tim.month ,tim.day ) - 4L ) % 7L );
		for ( uint8_t i = 0 ;i < 7 ;i++ ) {
			PG_drawWeekCheck( i ,i == tim.wday );
		}
		LCD_drawBMP( img004 ,120 ,12 ,9 ,9 );		/* "N"			*/
		LCD_drawBMP( img005 , 99 ,22 ,8 ,9 );		/* "" 		*/
		LCD_drawBMP( img006 ,120 ,22 ,8 ,9 );		/* "" 		*/
		PG_drawDate( pg );
	}
}
